/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * Authors:
 *  Olivier Tilloy <olivier.tilloy@canonical.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef SuperKeyMonitor_H
#define SuperKeyMonitor_H

#include <QObject>

class KeyMonitor;
class GConfItemQmlWrapper;

class SuperKeyMonitor : public QObject
{
    Q_OBJECT

public:
    SuperKeyMonitor();
    ~SuperKeyMonitor();

    static const uint SUPER_L = 133;
    static const uint SUPER_R = 134;

private:
    KeyMonitor* m_left;
    KeyMonitor* m_right;

    GConfItemQmlWrapper* m_enable_setting;

    bool getEnableSettingValue() const;

    void startMonitoring();
    void stopMonitoring();

private Q_SLOTS:
    void slotEnableSettingChanged();
};

#endif // SuperKeyMonitor_H

